; en - ENGLISH localisation /  
;------------------------------------------------;
;     Document used WINDOWS cp1251 codepage      ;
;         and compiled for SjASMPlus             ;
;------------------------------------------------;
;     WINDOWS cp1251  ;
;           SjASMPlus             ;
;------------------------------------------------;

      INCLUDE "local\en\help.asm"

      page    GUIPage
      ORG #C000

FONT    ; Loaded at addres #C000 in GUI page
        INCBIN "52f.bin"

;              PUBLIC and MAIN
;----------------------------------------------
  MACRO MSG_DISK_drive : DB "Drive" : ENDM
  MACRO MSG_DISK_Load_ : DB "Load_" : ENDM
  MACRO MSG_DISK_Save_ : DB "Save_" : ENDM
  MACRO MSG_DISK_Load  : DB "Load" : ENDM
  MACRO MSG_DISK_Save  : DB "Save" : ENDM
  MACRO MSG_OPER_or    : DB "OR"  : ENDM
  MACRO MSG_OPER_xor   : DB "XOR" : ENDM
  MACRO MSG_OPER_and   : DB "AND" : ENDM
  MACRO MSG_OPER_nop   : DB "NOP" : ENDM
  MACRO MSG_OPER_msk   : DB "MSK" : ENDM
  MACRO MSG_OPER_put   : DB "PUT" : ENDM
  MACRO MSG_PROCESS    : DB "Process_" : ENDM
  MACRO MSG_ERROR      : DB "Error" : ENDM

;              GUI Messages
;------------------------------------------------

 ; DOS messages

  MACRO MSG_DOS_rep : DB "   Repeat ? " : ENDM
  MACRO MSG_DOS_yes_no : DB "  Yes     No" : ENDM

  MACRO MSG_DOS_mess0 : DB "  No errors" : ENDM
  MACRO MSG_DOS_mess1 : DB "  No File" : ENDM
  MACRO MSG_DOS_mess2 : DB " File exists" : ENDM
  MACRO MSG_DOS_mess3 : DB "  Disk full" : ENDM
  MACRO MSG_DOS_mess4 : DB " Dir. is full" : ENDM
  MACRO MSG_DOS_mess5 : DB "   No Disk" : ENDM
  MACRO MSG_DOS_mess6 : DB "    Error!" : ENDM
  MACRO MSG_DOS_mess7 : DB "Break pressed" : ENDM
  MACRO MSG_DOS_hmess : DB " Some garbage" : ENDM
  MACRO MSG_FILE_big  : DB " File big!" : ENDM

 ;Filer messages
  MACRO MSG_Filer_FMan : DB "  File Manager" : ENDM

;               BGE Messages
;-------------------------------------------------

; BGE_Help
  MACRO MSG_Help_Intr   : DB "Introduction" : ENDM
  MACRO MSG_Help_MainM  : DB "Main menu" : ENDM
  MACRO MSG_Help_FileM  : DB "File menu" : ENDM
  MACRO MSG_Help_Plugs  : DB "Plugins & overlays" : ENDM
  MACRO MSG_Help_TxtOut : DB "Text" : ENDM
  MACRO MSG_Help_Win8   : DB "Windows x8" : ENDM
  MACRO MSG_Help_Win1   : DB "Windows x1" : ENDM
  MACRO MSG_Help_RGB    : DB "Select colour" : ENDM
  MACRO MSG_Help_Loupe  : DB "Loupe" : ENDM
  MACRO MSG_Help_Diz    : DB "Dithering" : ENDM
  MACRO MSG_Help_Mix    : DB "Mixing" : ENDM
  MACRO MSG_Help_2scr   : DB "Screen 2" : ENDM
  MACRO MSG_Help_Fill   : DB "Fill" : ENDM
  MACRO MSG_Help_Prims  : DB "Primitives" : ENDM
  MACRO MSG_Help_D_Can  : DB "Dithering Can" : ENDM
  MACRO MSG_Help_Cells  : DB "Cells" : ENDM
  MACRO MSG_Help_Misc   : DB "Miscelaneous" : ENDM
  MACRO MSG_Help_Sets   : DB "SetUp" : ENDM
  MACRO MSG_Help_Undo   : DB "Undo" : ENDM
  MACRO MSG_Help_Addi   : DB "Additionally" : ENDM
  MACRO MSG_Help_Hist   : DB "History" : ENDM
  MACRO MSG_Help_Auth   : DB "Authors" : ENDM

; File menu +
  MACRO MSG_DISK_File      : DB "File" : ENDM
  MACRO MSG_DISK_BLC_      : DB "Load BLC_" : ENDM
  MACRO MSG_DISK_SV_as_    : DB "Save as_" : ENDM
  MACRO MSG_DISK_SV_in_    : DB "Save in_" : ENDM
  MACRO MSG_DISK_LD_D_     : DB "Load double_" : ENDM
  MACRO MSG_DISK_SV_D_     : DB "Save double_" : ENDM
  MACRO MSG_DISK_RAMdisk_  : DB "RAM-disk_" : ENDM
  MACRO MSG_DISK_LD_p_     : DB "Load+_" : ENDM
  MACRO MSG_DISK_SV_p_     : DB "Save+_" : ENDM
  MACRO MSG_DISK_SprtSCAN  : DB "Sprite scan" : ENDM
  MACRO MSG_DISK_Files     : DB "Files" : ENDM

; SETUP
  MACRO MSG_SETUP_Head   : DB "SetUp" : ENDM
  MACRO MSG_SETUP_Mouse  : DB "Mouse" : ENDM
  MACRO MSG_SETUP_SMB    : DB "BSwap" : ENDM
  MACRO MSG_SETUP_Joi    : DB "Joystick" : ENDM
  MACRO MSG_SETUP_Turbo  : DB "Turbo drive" : ENDM
  MACRO MSG_SETUP_ExtMem : DB "Ext. memory" : ENDM
  MACRO MSG_SETUP_Cursor : DB "Cursor_" : ENDM
  MACRO MSG_SETUP_Step   : DB "Step " : ENDM    ; 5 bytes
  MACRO MSG_SETUP_Level  : DB "Level" : ENDM    ; 5 bytes
  MACRO MSG_SETUP_Speed  : DB "Speed" : ENDM    ; 5 bytes
  MACRO MSG_SETUP_Slow_M : DB "Slow mouse" : ENDM
  MACRO MSG_SETUP_Loup8  : DB "Loupe x8" : ENDM
  MACRO MSG_SETUP_Loup   : DB "Loupe_" : ENDM
  MACRO MSG_SETUP_LpGRD4 : DB "Old Grid 4" : ENDM

;FILES MINI COMMANDER
  MACRO MSG_FILES_View   : DB "View" : ENDM
  MACRO MSG_FILES_Load   : DB "Load" : ENDM
  MACRO MSG_FILES_Copy   : DB "Copy" : ENDM
  MACRO MSG_FILES_Copy1  : DB "Copy_" : ENDM
  MACRO MSG_FILES_Rename : DB "Rename" : ENDM
  MACRO MSG_FILES_Delete : DB "Delete" : ENDM

; Fill
 ; MACRO MSG_Fill_fill  : DB "Fill" : ENDM
 ; MACRO MSG_Fill_solid : DB "Solid" : ENDM
 ; MACRO MSG_Fill_textu : DB "Textured_" : ENDM
 ; MACRO MSG_Fill_edit  : DB "Editor_" : ENDM
 ; MACRO MSG_Fill_wash  : DB "Wash" : ENDM
 ; MACRO MSG_Fill_washP : DB "Wash+" : ENDM

; Texture
  MACRO MSG_Txtr_Fill  : DB "Fill" : ENDM
  MACRO MSG_Txtr_Pmsk  : DB "Pixels Mask" : ENDM
  MACRO MSG_Txtr_solid : DB "Solid" : ENDM
  MACRO MSG_Txtr_Sieve : DB "Sieve" : ENDM
  MACRO MSG_Txtr_Edit  : DB "Texture editor" : ENDM

; LOUPE
  MACRO MSG_LOUPE_curs    : DB "Cursor" : ENDM
  MACRO MSG_LOUPE_default : DB "Default" : ENDM
  MACRO MSG_LOUPE_cros    : DB "Crosshair" : ENDM
  MACRO MSG_LOUPE_mbut2   : DB "Button 2" : ENDM
  MACRO MSG_LOUPE_UtoPix  : DB "Undo -> pixel" : ENDM
  MACRO MSG_LOUPE_DelPix  : DB "Delete pixel" : ENDM
  MACRO MSG_LOUPE_UswPix  : DB "Undo <-> pixel" : ENDM
  MACRO MSG_LOUPE_Smooth  : DB "Smooth" : ENDM
  MACRO MSG_LOUPE_FMove   : DB "Scroll" : ENDM

; EDITS
  MACRO MSG_EDITS_edit    : DB "Edit" : ENDM
  MACRO MSG_EDITS_Clean   : DB "Clean" : ENDM
  MACRO MSG_EDITS_Invert  : DB "Invert" : ENDM
  MACRO MSG_EDITS_Take    : DB "Take scr" : ENDM
  MACRO MSG_EDITS_Put     : DB "Put scr" : ENDM
  MACRO MSG_EDITS_Slot    : DB "Slot>" : ENDM

; PIXELS MASK
 ; MACRO MSG_PMASK_Head    : DB "Pixels Mask" : ENDM
 ; MACRO MSG_PMASK_Sieve   : DB "Sieve" : ENDM
 ; MACRO MSG_PMASK_EdHead  : DB "Edit Mask" : ENDM
 ; MACRO MSG_PMASK_Clean   : DB "Clean" : ENDM
 ; MACRO MSG_PMASK_Invert  : DB "Invert" : ENDM
 ; MACRO MSG_PMASK_Take    : DB "Take scr." : ENDM
 ; MACRO MSG_PMASK_Put     : DB "Put scr." : ENDM
 ; MACRO MSG_PMASK_Slot1   : DB "Set 1" : ENDM
 ; MACRO MSG_PMASK_Slot2   : DB "Set 2" : ENDM
 ; MACRO MSG_PMASK_Slot3   : DB "Set 3" : ENDM
 ; MACRO MSG_PMASK_Please  : DB "First save the settings !" : ENDM

; WINDOWS
  MACRO MSG_WIN_HeadX1    : DB "Windows x1" : ENDM
  MACRO MSG_WIN_HeadX8    : DB "Windows x8" : ENDM
  MACRO MSG_WIN_Def       : DB "Define" : ENDM
  MACRO MSG_WIN_WhSCR     : DB "Whole screen" : ENDM
  MACRO MSG_WIN_Clear     : DB "Clear" : ENDM
  MACRO MSG_WIN_Copy      : DB "Copy window" : ENDM
  MACRO MSG_WIN_CopyP     : DB "Copy window+" : ENDM
  MACRO MSG_WIN_Move      : DB "Move window" : ENDM
  MACRO MSG_WIN_Inv       : DB "Invert" : ENDM
  MACRO MSG_WIN_ReScal    : DB "Re-Scale" : ENDM
  MACRO MSG_WIN_ReScalP   : DB "Re-Scale+" : ENDM
  MACRO MSG_WIN_FlipV     : DB "Flip vertical" : ENDM
  MACRO MSG_WIN_FlipH     : DB "Flip horizontal" : ENDM
  MACRO MSG_WIN_Mode      : DB "Mode: " : ENDM
  MACRO MSG_WIN_Brush     : DB "Brush" : ENDM
  MACRO MSG_WIN_Mult      : DB "Multiple" : ENDM
  MACRO MSG_WIN_Color     : DB "Color" : ENDM
  MACRO MSG_WIN_Scroll_   : DB "Scroll_" : ENDM
  MACRO MSG_WIN_Rot90     : DB "Rotate 90" : DB 248 : ENDM
  MACRO MSG_WIN_Effects   : DB "Effects_" : ENDM
  MACRO MSG_WIN_CurrCol   : DB "Current color" : ENDM
  MACRO MSG_WIN_ChangeCol : DB "Change color" : ENDM
  MACRO MSG_WIN_SelCol    : DB "Select color" : ENDM
  MACRO MSG_WIN_ScrollH   : DB "Scroll" : ENDM
  MACRO MSG_WIN_ScColor   : DB "Color" : ENDM
  MACRO MSG_WIN_ScrolX8   : DB "x8" : ENDM
  MACRO MSG_WIN_ScrolX1   : DB "x1" : ENDM
  MACRO MSG_WIN_ScrollRUN : DB " Start" : ENDM
  MACRO MSG_WIN_OutLine   : DB "Outline" : ENDM
  MACRO MSG_WIN_GrowOut   : DB "Grow out" : ENDM
  MACRO MSG_WIN_GrowIn    : DB "Grow in" : ENDM
  MACRO MSG_WIN_TakeOut   : DB "Take out" : ENDM
  MACRO MSG_WIN_Ink       : DB "Ink" : ENDM
  MACRO MSG_WIN_Paper     : DB "Paper" : ENDM
  MACRO MSG_WIN_Change    : DB "Change" : ENDM
  MACRO MSG_WIN_Undo      : DB "Undo" : ENDM

; BOX
  MACRO MSG_BOX_Head      : DB "Cells" : ENDM
  MACRO MSG_BOX_CurrCol   : DB "Current color" : ENDM
  MACRO MSG_BOX_Clear     : DB "Clear" : ENDM
  MACRO MSG_BOX_Inv       : DB "Invert" : ENDM
  MACRO MSG_BOX_InvP      : DB "Invert+" : ENDM
  MACRO MSG_BOX_Reverse   : DB "Reverse" : ENDM
  MACRO MSG_BOX_Copy      : DB "Copy cell" : ENDM
  MACRO MSG_BOX_CopyP     : DB "Copy cell+" : ENDM
  MACRO MSG_BOX_Scr2      : DB "Screen 2" : ENDM
  MACRO MSG_BOX_Mode      : DB "Mode: " : ENDM

; Chunks & Mixing
  MACRO MSG_Cnk_Dith        : DB "Dithering" : ENDM
  MACRO MSG_Cnk_Convert     : DB "Convert" : ENDM
  MACRO MSG_Cnk_Toscr       : DB "To screen" : ENDM
  MACRO MSG_Cnk_View        : DB "View" : ENDM
  MACRO MSG_Cnk_Bright      : DB "Brightness" : ENDM

  MACRO MSG_Mix_Mixing      : DB "Mixing" : ENDM
  MACRO MSG_Mix_2screen     : DB "2 screen" : ENDM
  MACRO MSG_Mix_Chunk       : DB "Chunk" : ENDM
  MACRO MSG_Mix_File        : DB "File_" : ENDM
  MACRO MSG_Mix_Txtr        : DB "Texture" : ENDM
  MACRO MSG_Mix_Scr2msk     : DB "ask +2" : ENDM
  MACRO MSG_Mix_Window      : DB "Window" : ENDM

; TEXTURE
  MACRO MSG_TXTR_head  : DB "Texture ?" : ENDM
  MACRO MSG_TXTR_edit  : DB "Edit" : ENDM
  MACRO MSG_TXTR_solid : DB "Solid" : ENDM

;BRUSH
  MACRO MSG_BRUSH_head       : DB "Brushes" : ENDM
  MACRO MSG_BRUSH_headED     : DB "Edit brush" : ENDM
  MACRO MSG_BRUSH_emptyER    : DB "Empty brush" : ENDM
 ; MACRO MSG_BRUSH_Slot       : DB "Slot" : ENDM
  MACRO MSG_BRUSH_Draw       : DB "   Draw" : ENDM
  MACRO MSG_BRUSH_storeIn    : DB "Store in_" : ENDM
  MACRO MSG_BRUSH_Step       : DB "Step" : ENDM
  MACRO MSG_BRUSH_Disp       : DB "Displac." : ENDM

; CoordXY
  MACRO MSG_Coord_Attr       : DB "Cells:" : ENDM
  MACRO MSG_Coord_Pix        : DB "Pixels:" : ENDM
  MACRO MSG_Coord_AdrAtr     : DB "Attr. addr" : ENDM
  MACRO MSG_Coord_AdrPix     : DB "Pixel addr" : ENDM

; DithCan
  MACRO MSG_DithCan_layer     : DB "Layer" : ENDM
  MACRO MSG_DithCan_tube      : DB "Tube" : ENDM
  MACRO MSG_DithCan_spray     : DB "Spray" : ENDM
  MACRO MSG_DithCan_aerosol   : DB "Aerosol" : ENDM
  MACRO MSG_DithCan_slowly    : DB "Slowly" : ENDM
  MACRO MSG_DithCan_increase  : DB "Increase" : ENDM
  MACRO MSG_DithCan_decrease  : DB "Decrease" : ENDM

